security:
#    enable_authenticator_manager: true
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    providers:
        web_service_user_provider:
            id: App\Security\User\WebServiceUserProvider
        auth0_provider:
            id: Auth0\Symfony\Security\UserProvider
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
#        main:
#            lazy: true
#            provider: users_in_memory
        secured_area:
            pattern: ^/api
            stateless: true
            custom_authenticators:
                - auth0.authorizer
#            provider: auth0_provider
            provider: web_service_user_provider

            # activate different ways to authenticate
            # https://symfony.com/doc/current/security.html#the-firewall

            # https://symfony.com/doc/current/security/impersonating_user.html
            # switch_user: true

    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_decision_manager:
        strategy: affirmative
        allow_if_all_abstain: false
        # Easy way to control access for large sections of your site
        # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/api/docs }
#        - { path: ^/api/graphql }
        - { path: ^/api/graphql/graphql_playground }
        - { path: ^/api/graphql/graphiql }
        - { path: ^/api/*, roles: ROLE_USING_TOKEN }

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
